package org.ow2.jasmine.vmm.agent.driver.util;

import java.io.IOException;
import java.io.InputStream;

import org.apache.log4j.Logger;
import org.ow2.jasmine.vmm.agent.driver.util.RemoteExec.Result;

public class LocalExec {

    static Logger logger = Logger.getLogger(RemoteExec.class);

    /***************************************************************************
     * @param cmd :command to execute
     * @return :return from running command cmd
     */
    static public Result command(final String command) throws Exception {
        StringBuffer outBuf = null;
        StringBuffer errBuf = null;
        Runtime runtime = Runtime.getRuntime();
        Process process = null;
        InputStream inStream = null;
        InputStream errStream = null;

        Result result = new Result();

        int ch;
        try {
            process = runtime.exec(command);
            inStream = process.getInputStream();
            errStream = process.getErrorStream();

            outBuf = new StringBuffer();
            errBuf = new StringBuffer();

            while ((ch = inStream.read()) != -1) {
                outBuf.append((char) ch + "");
            }

            while ((ch = errStream.read()) != -1) {
                errBuf.append((char) ch + "");
            }

            result.output = outBuf.toString();
            result.error = errBuf.toString();

        } catch (IOException e) {
            result.exitCode = -1;
            result.error = e.getMessage();
            result.output = "";
        } finally {
            try {
                if (process != null) {
                    result.exitCode = process.exitValue();
                    process.destroy();
                }
                if (inStream != null) {
                    inStream.close();
                }
            } catch (Exception e) {
            }
        }

        return result;
    }
}
